---
title: Visual Viewport API
slug: Web/API/Visual_Viewport_API
tags:
  - API
  - Experimental
  - Layout
  - Overview
  - Reference
  - layout viewport
  - viewport
  - visual
  - visual viewport
---
<p>{{DefaultAPISidebar("Visual Viewport")}}{{draft}}</p>

<p class="summary">The <strong>Visual Viewport API</strong> provides an explicit mechanism for querying and modifying the properties of the window's {{Glossary("visual viewport")}}. The visual viewport is the visual portion of a screen excluding on-screen keyboards, areas outside of a pinch-zoom area, or any other on-screen artifact that doesn't scale with the dimensions of a page.</p>

<h2 id="Visual_Viewport_concepts_and_usage">Visual Viewport concepts and usage</h2>

<p>The mobile web contains two viewports, the layout viewport and the visual viewport. The layout viewport covers all the elements on a page and the visual viewport is what is actually visible on the screen. When the user pinch-zooms into the page, the visual viewport shrinks but the layout viewport is unchanged. User-interface features like the on-screen keyboard (OSK) can shrink the visual viewport without affecting the layout viewport.</p>

<p>What happens when a web page element needs to be visible on screen regardless of the visible portion of a web page? For example, what if you need a set of image controls to remain on screen regardless of the pinch zoom level of the device? Current browsers vary in how they handle this. The visual viewport lets web developers solve this by positioning elements relative to what's shown on screen. </p>

<p>To access a window's visual viewport, you can obtain a {{domxref("VisualViewport")}} object from the {{domxref("window.visualViewport")}} property. The object includes a set of properties describing the viewport. It also adds two events, <code>onresize</code> and <code>onscroll</code>, that fire whenever the visual viewport changes. These events allow you to position elements relative to the visual viewport that would normally be anchored to the layout viewport. </p>

<h2 id="Accessing_the_API">Accessing the API</h2>

<dl>
 <dt>{{domxref("window.visualViewport")}} {{ReadOnlyInline}}</dt>
 <dd>A read-only reference to the window's {{domxref("VisualViewport")}} object. If this property doesn't exist, the API is unsupported.</dd>
</dl>

<h2 id="Interfaces">Interfaces</h2>

<dl>
 <dt>{{DOMxRef("VisualViewport")}}</dt>
 <dd>Represents the visual viewport for a given window. A window's <code>VisualViewport</code> object provides information about the viewport's position and size, and receives the {{domxref("VisualViewport.resize_event", "resize")}} and event:VisualViewport:scroll events you can onitor to know when chances occur to the window's viewport.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>The code below is based on the sample the specification, though it adds a few things that make it function better. It shows a function called <code>viewportHandler()</code>. When called it queries the <code>offsetLeft</code> and <code>height</code> properties for values it uses in a CSS <code>translate()</code> method. You invoke this function by passing it to <em>both</em> event calls.</p>

<p>One thing that may not be clear in this example is the use of the <code>pendingUpdate</code> flag and the call to <code>requestAnimationFrame()</code>. The <code>pendingUpdate</code> flag serves to prevent multiple invocations of the transfrom that can occur when <code>onresize</code> and <code>onscroll</code> fire at the same time. Using <code>requestAnimationFrame()</code> ensures that the transform ocurrs before the next render.</p>

<pre class="brush: js notranslate">let pendingUpdate = false;

function viewportHandler(event) {
  if (pendingUpdate) return;
  pendingUpdate = true;

  requestAnimationFrame(() =&gt; {
    pendingUpdate = false;
    var layoutViewport = document.getElementById('layoutViewport');

    // Since the bar is position: fixed we need to offset it by the
    // visual viewport's offset from the layout viewport origin.
    var viewport = event.target;
    var offsetLeft = viewport.offsetLeft;
    var offsetTop = viewport.height
                - layoutViewport.getBoundingClientRect().height
                + viewport.offsetTop;

    // You could also do this by setting style.left and style.top if you
    // use width: 100% instead.
    bottomBar.style.transform = 'translate(' +
                                offsetLeft + 'px,' +
                                offsetTop + 'px) ' +
                                'scale(' + 1/viewport.scale + ')'
    })
}

window.visualViewport.addEventListener('scroll', viewportHandler);
window.visualViewport.addEventListener('resize', viewportHandler);</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Visual Viewport','#the-visualviewport-interface','VisualViewport')}}</td>
   <td>{{Spec2('Visual Viewport')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>
<div>

<p>{{Compat("api.VisualViewport")}}</p>
</div>
</div>
